///home/berryj/link/bin/genMethods "-g" "-t" "Sequence<Vertex*>" "-h" "List" "-I" "LINK/graph/Vertex.h" "-I" "LINK/basic/Sequence.h" "-I" "LINK/basic/List.h" "-d" "graph" 
#include <stk.h>
#include <LINK/stkWrapper/LINK_STk.h>

#include <LINK/graph/Vertex.h>

#include <LINK/basic/Sequence.h>

#include <LINK/basic/List.h>

#include <LINK/stkWrapper/Wrapper.h>
#include <LINK/stkWrapper/Register.h>
#include <LINK/stkWrapper/ListWrapper.h>


typedef Sequence<Vertex*> _Sequence_Vertex__;
typedef List<Sequence<Vertex*> > _List_Sequence_Vertex___;
static List<Sequence<Vertex*> > s__List_Sequence_Vertex___;

#define _List_Sequence_Vertex___DATA(x) ((List<Sequence<Vertex*> >*) (EXTDATA(x)))
#define _List_Sequence_Vertex___IS_DATA(x) (TYPEP(x, tc_CXXwrapper) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<List<Sequence<Vertex*> > >::type))
#define _List_Sequence_Vertex___ISNT_DATA(x) (!_List_Sequence_Vertex___IS_DATA(x))

#define _List_Sequence_Vertex___CXX_DATA(x) (*(List<Sequence<Vertex*> >*) (EXTDATA(VAL(x))))
#define _List_Sequence_Vertex___CXX_IS_DATA(x) (INSTANCEP(x) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<List<Sequence<Vertex*> > >::type))
#define _List_Sequence_Vertex___CXX_ISNT_DATA(x) (!_List_Sequence_Vertex___CXX_IS_DATA(x))


PRIMITIVE STk_init__List_Sequence_Vertex___()
{
	Wrapper<_List_Sequence_Vertex___>::type = STk_new_CXXwrapper_id(
			Wrapper<_List_Sequence_Vertex___>::name, 
			"",
			(void (*)(SCM x, SCM port, int mode))
			ListWrapper<_Sequence_Vertex__>::displayTypedList,
			(void (*)(SCM x))ListWrapper<_Sequence_Vertex__>::markTypedList,
			(void (*)(SCM x))ListWrapper<_Sequence_Vertex__>::freeTypedList);
	Tcl_InitHashTable(&Register<_List_Sequence_Vertex___>::objTable, TCL_ONE_WORD_KEYS);
	return UNDEFINED;
}

void genExtra_List_Sequence_Vertex___Methods(void);

PRIMITIVE STk_init_methods__List_Sequence_Vertex___()
{
	STk_add_new_cpp_primitive("List-Sequence-Vertex-make", tc_subr_0, 
	(PRIMITIVE (*)(...))  ListWrapper<_Sequence_Vertex__>::makeLinkList);
	STk_add_new_cpp_primitive("List-Sequence-Vertex?", tc_subr_1, 
	(PRIMITIVE (*)(...))  ListWrapper<_Sequence_Vertex__>::linkListP);
	STk_add_new_cpp_primitive("list->List-Sequence-Vertex", tc_subr_1, 
	(PRIMITIVE (*)(...))  ListWrapper<_Sequence_Vertex__>::stkList2LinkList);
	STk_add_new_cpp_primitive("List-Sequence-Vertex->list", tc_subr_1, 
	(PRIMITIVE (*)(...))  ListWrapper<_Sequence_Vertex__>::linkList2STkList);
	genExtra_List_Sequence_Vertex___Methods();
	return UNDEFINED;
}
